0001 ***********************************************************
0002 *                                                         *
0003 *            3P+S Testing Program for Sol-20              *
0004 *                                                         *
0005 ***********************************************************
0006 *
0007 * FileName 3P+S.T
0008 *
0009 * SET OPERATORS *
0010  ORG 0F000H
0011  XEQ 0C004H
0012 *
0000 * SYSTEM EQUATES
0000 RTRN EQU 0C004H
0000 *
0013 * MASK EQUATES
0000 SAMSK EQU 00H
0000 SIMSK EQU 01H
0000 PAMSK EQU 02H
0000 PBMSK EQU 03H
0000 *
0014 MASK1 EQU 3FH   Mask used to Remove D7 and D6 from result
0015 MASK2 EQU 3FH   Mask used to Remove D7 and D6 from result
0016 GMSK1 EQU 015H  Complemented Mask used to check result
0017 GMSK2 EQU 02AH  Complemented Mask used to check result
0018 *
0019 * FOUR PHASE WONDER
0000  NOP
0000  JMP START
0000 *
0000 START EQU $
0020 * MAIN ROUTINE
0000  CALL PERSE
0000  CALL PATST
0000  CALL PBTST
0000  CALL SITST
0000  CALL SATST
0000  JMP RTRN
0034 *
0035 * PARALLEL PORT A TESTER
0036 *
0037 PATST EQU $
0048  MVI C,PAMSK    LOAD C REGISTER WITH OUTPUT PORT
0000  CALL PRTCK     CHECK THE PORT
0000  RET .
0050 *
0052 * End of the Parallel Port A and Strobe A Test Routine
0053 *
0054 * PARALLEL PORT B TESTER
0055 *
0056 PBTST EQU $
0057  MVI C,PBMSK    LOAD C REGISTER WITH OUTPUT PORT
0068  CALL PRTCK     CHECK THE PORT
0000  RET .
0070 *
0071 * End of Parallel Port B and Strobe B Test Routine
0072 *
0096 * SERIAL PORT TESTER
0097 *
0098 SITST NOP
0099  MVI C,SIMSK    LOAD C REGISTER WITH OUTPUT PORT
0120  CALL PRTCK     CHECK THE PORT
0000  RET .
0121 *
0122 *
0123 * End of the Serial Interface Testing Routine
0124 *
0000 * STATUS PORT TESTER
0000 *
0075 SSTST EQU $
0076  MVI A,00H      Load Accumulator with 00H
0077  STA ERRS       Store Accumulator in Location ERRS
0078  STA PORT       Store Accumulator in Location Port
0079  MVI A,0FFH     Load Print Flag
0080  STA FLAG
0081  LXI H,MSST     Load Message Pointer
0082  CALL TEXTO     Output Message
0083 SSTL1 NOP       Label Point
0084  CALL SINT1     Output First Check Mask
0085  CALL SCK1      Verify that the Mask received is correct
0086  CALL SINT2     Output Second Check Mask
0087  CALL SCK2      Verify that the Mask received is correct
0088  CALL PAST      Output Condition of Status Check
0089  CALL NEXT      Check for Continue Command
0090  RZ             Loop Exit when Command is Given
0091  JMP SSTL1      Continue to Loop
0092 *
0094 * End of the Status Ports Test Routine
0095 *
0125 * Begining of Status Masking and Checking Subroutines
0126 *
0127 * SET UP STATUS PORT PATTERN #1
0128 *
0129 SINT1 NOP
0130  MVI A,00H      SET PUS=1,PIE=0
0131  OUT 0FAH       Output to Sol Status Port
0132  MVI A,08H      SET C2,C4=1;C3,C5=0:P.C.=0
0133  OUT SAPRT      Output to 3P+S Status Port <C>
0134  RET
0135 *
0136 * SET UP STATUS PORT PATTERN #2
0137 *
0138 SINT2 NOP
0139  MVI A,18H      SET PUS=0,PIE=1
0140  OUT 0FAH       Output to Sol Status Port
0141  MVI A,03H      SET C2,C4=0;C3,C5=1:P.C.=1
0142  OUT SAPRT      Output to 3P+S Status Port <C>
0143  RET
0144 *
0145 * FIRST CHECK OF CORRECT STATUS
0146 *
0147 SCK1 NOP
0148  CALL PORT0     Input 3P+S Status Port <C>
0149  ANI MASK1      Mask Out C0 and C1
0150  XRI GMSK1      Check with Expect Value
0151  STA ERRS       Store Errors if any
0152  IN 02H         Clear FA Flag
0153  IN 03H         Clear FB Flag
0154  RET
0155 *
0156 * SECOND CHECK OF CORRECT STATUS
0157 *
0158 SCK2 NOP
0159  CALL PORT0     Input 3P+S Status Port <C>
0160  ANI MASK2      Mask Out C0 and C1
0161  XRI GMSK2      Check with Expect Value
0162  MOV B,A        Save Accumulator in B Register
0163  LDA ERRS       Load Accumulator with Error Data
0164  ORA B          "OR" in New Error Data if any
0165  STA ERRS       Store Error data
0166  IN 02H         Clear FA Flag
0167  IN 03H         Clear FB Flag
0168  RET
0169 *
0170 * End of Status Masking and Checking Subroutines
0171 *
0172 * CHECK THE PORTS *
0173 *
0174 PRTCK EQU $
0175  LXI D,0        Load D and E Registers with 00H
0000 *
0178 LOOP EQU $      Move Data in E to Output Register B
0000  MOV B,E
0179  CALL TOUT      Output Data (Port Specified REGISTER C )
0180  CALL TINP      Input Data  (Port Specified REGISTER C )
0181  XRA E          Check Data Send with Data Received
0182  JZ TGOOD       "If Data is Good skip to TGOOD"
0183  MOV B,A        Store Accumulator in B Register
0184  MOV A,D        Load Accumulator with ERROR REGISTER
0185  ORA B          "OR" in New Error Data
0186  MOV D,A        Store Error Data
0187 TGOOD EQU $
0188  INR E          Increment Loop index
0189  MOV A,E        Move E Register to Accumulator <PATTERN>
0190  CPI TOKEN      Check to see if finished     <256 LOOPS?>
0191  JNZ LOOP       No then loop again
0192  JMP DSTAT      After we are finished return
0193 *
0000 DSTAT EQU $
0000 * OUTPUTS THE BIT PATTERN OF GOOD AND BAD BITS
0000  MVI B,BYTE
0000  MVI A,BLANK
0000  LHLD SCRNT
0000  MOV M,A
0000  INX H
0000  SHLD SCRNT
0000 *
0000 DSTA1 EQU $
0000  MOV A,C
0000  RLC
0000  MOV C,A
0000  MVI B,'G'
0000
0571 *
0572 * END OF 3P+S *
0573 *
0574  END
